'------------------------------------------------------
'Commander Spleen's Commander Keen 1 Sound Editor (WIP)
'
'Adapted from CK Guy's Commander Keen 1-3
'    Importer, Exporter, and Player
'
'======================================================

DECLARE SUB setlongnote ()
DECLARE SUB setstringnote ()
DEFINT A-Z

DECLARE SUB drawinterface ()
DECLARE SUB drawbackdrop ()
DECLARE SUB redrawwindows ()
DECLARE FUNCTION hex2$ (n!)

'================= EDIT FUNCTION =======================
DEFINT A-Z
DECLARE FUNCTION Edit (Column, Row, Length, Text$)

'Colours and ASCII or scan codes of keys
CONST FgCol = 7, BgCol = 13, Enter = 13, Escape = 27, UpArrow = 72
CONST DownArrow = 80, LeftArrow = 75, RightArrow = 77, Home = 71
CONST EndKey = 79, Ins = 82, Del = 83, Backspace = 8

'This function takes two screen coordinates (Row, Column) and paints an
'edit field in reverse video of length Length with Text$ as default value.
'The text can be edited using the left and right arrow keys, Home, End, Del
'and Backspace. Ins switches between insert mode (default) and typeover mode.
'On completion, the parameter Text$ contains the edited string.
'The function returns the ASCII or scan code of the key that was used to
'end the editing (can be up or down arrow, Enter or Escape).

'========================== /EDIT FUNCTION =============================

'**************************
  DIM SHARED version AS STRING
  version = "*Sep12 2005"
'**************************

CONST numberofwindows = 2, TRUE = 1, FALSE = 0
CONST all = 0, winsound = 1, winvis = 2

TYPE WINDOWFRAME
  xpos AS INTEGER
  ypos AS INTEGER
  xsize AS INTEGER
  ysize AS INTEGER
  FgCol AS INTEGER
  BgCol AS INTEGER
  redraw AS INTEGER
  viewoffset AS INTEGER
END TYPE

TYPE sndtype
  offset AS INTEGER
  priority AS STRING * 1
  exist AS STRING * 1
  sndname AS STRING * 12
END TYPE

DIM soundcount AS STRING * 1
DIM prevbyte AS STRING * 1
DIM byte AS STRING * 1

DIM SHARED soundlength(1 to 63) AS INTEGER
DIM SHARED wordnote AS STRING * 2
DIM SHARED longnote AS LONG
DIM SHARED copynote AS STRING * 2
DIM SHARED longinputnote AS LONG
DIM SHARED longtempnote AS LONG
DIM SHARED intbyte AS INTEGER
DIM SHARED snd(1 to 63) AS sndtype
DIM SHARED wintitle(numberofwindows) AS STRING
DIM SHARED win(numberofwindows) AS WINDOWFRAME
DIM SHARED wincur AS INTEGER  '1 = Sound Box, 2 = Visualisation
DIM SHARED currentnote AS INTEGER     'Keep track of which note is being edited
DIM SHARED currentsound AS INTEGER
DIM SHARED range AS LONG

wincur = 1
currentnote = 1
currentsound = 1
range = 1200  'Range to display

'Initialise window data
FOR i = 1 TO numberofwindows
  READ win(i).xpos, win(i).ypos, win(i).xsize, win(i).ysize, win(i).FgCol, win(i).BgCol, wintitle(i)
  win(i).redraw = TRUE
NEXT

win(winsound).viewoffset = 1
win(winvis).viewoffset = 0

DIM meep(17, 24) AS INTEGER
DIM keenfx(56, 20) AS INTEGER
DIM soundwave(8, 14) AS INTEGER

'Read data
'Meep
FOR y = 0 TO 23
  FOR x = 0 TO 16
    READ z
    meep(x, y) = z
  NEXT
  PRINT
NEXT
'Keenfx
FOR y = 0 TO 19
  FOR x = 0 TO 55
    READ z
    keenfx(x, y) = z
  NEXT
NEXT
'Soundwave
FOR y = 0 TO 13
  FOR x = 0 TO 7
    READ z
    soundwave(x, y) = z
  NEXT
NEXT

'Draw
'Background
FOR x = 1 TO 80
  FOR y = 1 TO 24
    COLOR 11
    PRINT CHR$(219);
  NEXT
NEXT

COLOR 15, 4
LOCATE 18, 1
PRINT STRING$(80, 205);
PRINT STRING$(80, " ");
PRINT STRING$(80, " ");
PRINT STRING$(80, 205);

LOCATE 19, 18
PRINT "Sound Editor for Keen:Vorticons";
LOCATE 20, 21
PRINT "By Commander Spleen 2005"


'Meep
FOR y = 0 TO 23
  FOR x = 0 TO 16
    COLOR meep(x, y)
    LOCATE y + 1, x + 1
    IF meep(x, y) <> 11 THEN PRINT CHR$(219);
  NEXT
NEXT
'Keenfx
FOR y = 0 TO 19
  FOR x = 0 TO 55
    COLOR keenfx(x, y), keenfx(x, y)
    LOCATE y + 2, x + 17
    IF keenfx(x, y) <> 11 THEN PRINT CHR$(177);
  NEXT
NEXT
'Soundwave
FOR y = 0 TO 13
  FOR x = 0 TO 7
    COLOR soundwave(x, y), 0
    LOCATE y + 6, x + 73
    IF soundwave(x, y) <> 11 THEN PRINT CHR$(219);
  NEXT
NEXT

COLOR 11, 0

in$ = INPUT$(1)

'$DYNAMIC

OPEN "SOUNDS.CK1" FOR BINARY AS #1

SEEK #1, 7  'Byte 06 holds number of sounds
'GET #1, , soundcount
soundcount = CHR$(63)

SEEK #1, 17
FOR i = 1 to 63 'Collect the sound definitions
  GET #1, , snd(i)
NEXT i

REDIM SHARED soundeffect(1 to 63) AS STRING
'PRINT "Sounds:"; ASC(soundcount)

FOR i = 1 TO 62
  'IF snd(i).sndname = "__UnNamed__ " THEN EXIT FOR
  soundlength(i) = snd(i + 1).offset - snd(i).offset
  PRINT i; snd(i).sndname; " Size: "; soundlength(i)
  IF highest < soundlength(i) THEN highest = soundlength(i)
NEXT

'PRINT "Largest sound effect: "; highest

SEEK #1, snd(1).offset + 1                       'Start at the beginning
'Compile soundeffect array
FOR i = 1 TO 62
  soundlength = snd(i + 1).offset - snd(i).offset  'Determine length of sound
  soundeffect(i) = ""
  FOR j = 0 TO soundlength(i) - 1
    GET #1, , byte
    'PRINT ASC(byte);
    'Invert the byte...
    IF ASC(byte) > 0 AND ASC(byte) < 254 THEN byte = CHR$(255 - ASC(byte))
    soundeffect(i) = soundeffect(i) + byte       'Add the current byte to the soundeffect
  NEXT
NEXT

CLS
drawbackdrop
redrawwindows
DO
  DO: in$ = INKEY$: LOOP WHILE in$ = ""
  wordnote = MID$(soundeffect(currentsound), currentnote * 2 - 1, 2)
  longnote = ASC(MID$(wordnote, 2))
  longnote = longnote * 256 + ASC(wordnote)
  LOCATE 1, 1
  SELECT CASE in$
  CASE CHR$(13)
    i = 1
    PLAY "mb"
    DO
      wordnote = MID$(soundeffect(currentsound), i, 2)
      SOUND 0, .142857
      OUT 67, 182
      OUT 66, 255 - ASC(wordnote)
      OUT 66, 255 - ASC(MID$(wordnote, 2))
      DO WHILE PLAY(0): LOOP
      DO WHILE INKEY$ > "": LOOP
      i = i + 2
    LOOP UNTIL wordnote = CHR$(255) + CHR$(255)
    PLAY "mf"
  CASE " "
    PLAY "mb"
    SOUND 0, .142857
    OUT 67, 182
    OUT 66, 255 - ASC(wordnote)
    OUT 66, 255 - ASC(MID$(wordnote, 2))
    DO WHILE PLAY(0): LOOP
    PLAY "mf"
  CASE CHR$(0) + "H"                            'UP
    IF wincur = winsound THEN
      IF currentsound > 1 THEN
        currentsound = currentsound - 1
        currentnote = 1
        win(winvis).viewoffset = 0
        win(winsound).redraw = TRUE
        win(winvis).redraw = TRUE
        IF currentsound < win(winsound).viewoffset THEN
          win(winsound).viewoffset = win(winsound).viewoffset - 1
        END IF
      END IF
    END IF

    IF wincur = winvis THEN
       IF longnote <= 65535 - 16 THEN
         longnote = longnote + 16
       ELSE
         longnote = 65535
       END IF
       
       MID$(soundeffect(currentsound), currentnote * 2 - 1, 1) = CHR$(longnote MOD 256)
       MID$(soundeffect(currentsound), currentnote * 2, 1) = CHR$(longnote \ 256)

       win(winvis).redraw = TRUE
    END IF

  CASE CHR$(0) + "I"                            'PGUP
    IF wincur = winvis THEN
       IF longnote <= 65535 - 256 THEN
         longnote = longnote + 256
       ELSE
         longnote = 65535
       END IF
      
       MID$(soundeffect(currentsound), currentnote * 2 - 1, 1) = CHR$(longnote MOD 256)
       MID$(soundeffect(currentsound), currentnote * 2, 1) = CHR$(longnote \ 256)

       win(winvis).redraw = TRUE
    END IF

  CASE CHR$(0) + "P"                            'DOWN
    IF wincur = winsound THEN
      IF currentsound < 63 THEN
        currentsound = currentsound + 1
        currentnote = 1
        win(winvis).viewoffset = 0
        win(winsound).redraw = TRUE
        win(winvis).redraw = TRUE
        IF currentsound > win(winsound).viewoffset + win(winsound).ysize - 2 THEN
          win(winsound).viewoffset = win(winsound).viewoffset + 1
        END IF
      END IF
    END IF
 
    IF wincur = winvis THEN
       IF longnote >= 16 THEN
         longnote = longnote - 16
       ELSE
         longnote = 0
       END IF
      
       MID$(soundeffect(currentsound), currentnote * 2 - 1, 1) = CHR$(longnote MOD 256)
       MID$(soundeffect(currentsound), currentnote * 2, 1) = CHR$(longnote \ 256)

       win(winvis).redraw = TRUE
    END IF

  CASE CHR$(0) + "Q"                            'PGDN
    IF wincur = winvis THEN
       IF longnote >= 256 THEN
         longnote = longnote - 256
       ELSE
         longnote = 0
       END IF
      
       MID$(soundeffect(currentsound), currentnote * 2 - 1, 1) = CHR$(longnote MOD 256)
       MID$(soundeffect(currentsound), currentnote * 2, 1) = CHR$(longnote \ 256)

       win(winvis).redraw = TRUE
    END IF

  CASE CHR$(0) + "K"                            'LEFT
    IF wincur = winvis THEN
      IF currentnote > 1 THEN
        currentnote = currentnote - 1
        win(winvis).redraw = TRUE
        IF currentnote < win(winvis).viewoffset + 1 THEN
          win(winvis).viewoffset = win(winvis).viewoffset - 1
        END IF
      END IF
    END IF
  CASE CHR$(0) + "M"                            'RIGHT
    IF wincur = winvis THEN
      IF currentnote < LEN(soundeffect(currentsound)) / 2 - 1 THEN
        currentnote = currentnote + 1
        win(winvis).redraw = TRUE
        IF currentnote > win(winvis).viewoffset + win(winvis).xsize - 2 THEN
          win(winvis).viewoffset = win(winvis).viewoffset + 1
        END IF
      END IF
    END IF
  CASE CHR$(9)
    win(wincur).redraw = TRUE
    wincur = wincur + 1
    IF wincur > numberofwindows THEN wincur = 1
    win(wincur).redraw = TRUE

  CASE "z", "Z"
    IF wincur = winvis THEN
      IF range < 65536 THEN range = range + 1200
      win(winvis).redraw = TRUE
    END IF
 
  CASE "x", "X"
    IF wincur = winvis THEN
      IF range > 1200 THEN range = range - 1200
      win(winvis).redraw = TRUE
    END IF

  CASE "c", "C"
    IF wincur = winvis THEN
      copynote = MID$(soundeffect(currentsound), currentnote * 2 - 1, 2)
      win(winvis).redraw = TRUE
    END IF

  CASE "v", "V"
    IF wincur = winvis THEN
      MID$(soundeffect(currentsound), currentnote * 2 - 1, 2) = copynote
      win(winvis).redraw = TRUE
    END IF

  CASE CHR$(0) + "R"                            'INS
    IF wincur = winvis THEN
      LOCATE win(winvis).ypos + win(winvis).ysize, win(winvis).xpos + 8
      directnote$ = ""
      DO
        KeyPressed = Edit(win(winvis).xpos + win(winvis).xsize - 8, win(winvis).ypos + win(winvis).ysize, 5, directnote$)
        IF KeyPressed = Enter THEN
          IF VAL(directnote$) <= 65535 AND VAL(directnote$) >= 0 THEN
            longnote = VAL(directnote$)
            MID$(soundeffect(currentsound), currentnote * 2 - 1, 1) = CHR$(longnote MOD 256)
            MID$(soundeffect(currentsound), currentnote * 2, 1) = CHR$(longnote \ 256)
            win(winvis).redraw = TRUE
            EXIT DO
          END IF
        END IF
      LOOP UNTIL KeyPressed = Escape
    END IF

  CASE "+", "="
    IF wincur = winvis THEN
      soundeffect(currentsound) = LEFT$(soundeffect(currentsound), soundlength(currentsound) - 2)
      soundeffect(currentsound) = soundeffect(currentsound) + CHR$(0) + CHR$(0) + CHR$(255) + CHR$(255)
      soundlength(currentsound) = soundlength(currentsound) + 2
      win(winvis).redraw = TRUE
    END IF

  CASE "-"
    IF wincur = winvis THEN
      IF soundlength(currentsound) > 16 THEN
        soundeffect(currentsound) = LEFT$(soundeffect(currentsound), soundlength(currentsound) - 4)
        soundeffect(currentsound) = soundeffect(currentsound) + CHR$(255) + CHR$(255)
        soundlength(currentsound) = LEN(soundeffect(currentsound))
        IF currentnote >= LEN(soundeffect(currentsound)) / 2 THEN currentnote = currentnote - 1
        win(winvis).redraw = TRUE
      END IF
    END IF

  CASE "i", "I"
    IF wincur = winvis THEN
      longnote = 65535 - longnote
      MID$(soundeffect(currentsound), currentnote * 2 - 1, 1) = CHR$(longnote MOD 256)
      MID$(soundeffect(currentsound), currentnote * 2, 1) = CHR$(longnote \ 256)
      win(winvis).redraw = TRUE
    END IF

  CASE "f", "F"
    IF wincur = winvis THEN
      tempnote$ = ""
        FOR i = soundlength(currentsound) - 3 TO 1 STEP -2
          wordnote = MID$(soundeffect(currentsound), i, 2)
          tempnote$ = tempnote$ + LEFT$(wordnote, 1) + RIGHT$(wordnote, 1)
        NEXT
      soundeffect(currentsound) = tempnote$ + CHR$(255) + CHR$(255)
      win(winvis).redraw = TRUE
    END IF

  CASE "s", "S"
    CLOSE #1
    KILL "sounds.ck1"

    compiledoffset& = 1024
    compiledsounds$ = ""
    FOR i = 1 to 63
      FOR j = 1 TO soundlength(i)
        IF MID$(soundeffect(i), j, 1) < CHR$(255) AND MID$(soundeffect(i), j, 1) > CHR$(0) THEN
          MID$(soundeffect(i), j, 1) = CHR$(255 - ASC(MID$(soundeffect(i), j, 1)))
        END IF
      NEXT
      snd(i).offset = compiledoffset&
      compiledsounds$ = compiledsounds$ + soundeffect(i)
      compiledoffset& = compiledoffset& + soundlength(i)
      FOR j = 1 TO soundlength(i)
        IF MID$(soundeffect(i), j, 1) < CHR$(255) AND MID$(soundeffect(i), j, 1) > CHR$(0) THEN
          MID$(soundeffect(i), j, 1) = CHR$(255 - ASC(MID$(soundeffect(i), j, 1)))
        END IF
      NEXT
    NEXT

    OPEN "sounds.ck1" FOR OUTPUT AS #1
    PRINT #1, STRING$(16, 0);                'Empty header, for now.
    FOR i = 1 to 63
      PRINT #1, CHR$(snd(i).offset MOD 256) + CHR$(snd(i).offset \ 256);
      PRINT #1, snd(i).priority;
      PRINT #1, snd(i).exist;
      PRINT #1, snd(i).sndname;
    NEXT

    PRINT #1, compiledsounds$               'The fun stuff.
    CLOSE #1
 
  CASE "0"
    IF wincur = winvis THEN
      byte = MID$(soundeffect(currentsound), currentnote, 1)
      IF byte > CHR$(0) THEN
        MID$(soundeffect(currentsound), currentnote, 1) = CHR$(0)
      END IF
      win(winvis).redraw = TRUE
    END IF
  END SELECT
  redrawwindows
LOOP UNTIL in$ = CHR$(27)
CLOSE #1
SYSTEM

'Window information:
'xpos, ypos, xsize, ysize, fgcol, bgcol
'1
DATA 3, 7, 17, 15, 15, 9, "Sound Box"
'2
DATA 23, 7, 52, 15, 15, 13, "Visualisation"

DATA 11,11,11,11,11,00,00,00,00,00,00,11,11,11,11,11,11
DATA 11,11,11,11,00,10,10,10,02,02,02,00,00,11,11,11,11
DATA 11,11,11,00,10,10,10,02,02,02,02,02,02,00,11,11,11
DATA 11,11,11,00,10,10,02,02,02,02,02,02,02,00,11,11,11
DATA 11,11,00,10,10,02,15,15,02,02,02,15,15,00,00,11,11
DATA 11,11,00,10,10,15,15,15,15,02,15,15,15,00,02,00,11
DATA 11,11,00,10,10,15,00,15,15,02,00,15,15,00,02,02,00
DATA 11,11,00,10,10,15,00,15,15,02,00,15,15,00,02,00,11
DATA 11,11,00,10,10,02,15,15,15,02,15,15,15,00,00,11,11
DATA 11,11,00,10,10,02,02,02,02,02,02,02,02,00,11,11,11
DATA 11,00,00,10,10,02,00,00,00,00,00,00,00,00,11,11,11
DATA 00,10,00,00,00,02,00,00,00,00,00,11,11,11,11,11,11
DATA 00,10,02,02,02,02,00,00,00,00,00,11,11,11,11,11,11
DATA 00,00,10,02,00,02,02,00,00,00,00,11,11,11,11,11,11
DATA 00,10,02,00,02,02,02,00,00,00,00,11,11,11,11,11,11
DATA 11,00,00,10,02,02,02,02,00,00,00,00,00,00,11,11,11
DATA 11,11,00,10,02,10,02,02,02,02,02,02,02,00,11,11,11
DATA 11,11,11,00,10,10,10,02,02,02,02,02,02,00,11,11,11
DATA 11,11,11,11,00,10,10,10,02,02,02,00,00,11,11,11,11
DATA 11,11,11,00,10,02,00,00,00,00,00,00,11,00,00,11,11
DATA 11,11,00,10,02,00,11,11,00,02,02,02,00,02,02,00,11
DATA 11,00,10,10,02,02,00,11,11,00,02,02,02,02,00,11,11
DATA 00,10,10,02,02,02,02,00,11,11,00,02,02,00,11,11,11
DATA 11,00,00,00,00,00,00,11,11,11,11,00,00,11,11,11,11

DATA 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,00,11,11,11,11,11,11,11,11,11
DATA 11,11,11,11,00,11,11,11,11,00,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,09,09,00,11,11,11,11,11,11,11,11
DATA 11,11,11,00,04,00,11,11,00,04,00,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,09,09,00,09,00,11,11,11,11,11,11,11
DATA 11,11,00,12,04,00,11,00,12,04,00,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,09,09,00,00,11,11,11,11,11,11,11,11
DATA 11,11,00,12,04,00,11,00,12,04,00,11,11,00,00,00,00,11,11,11,11,11,11,00,00,00,00,11,11,11,00,00,00,11,00,00,00,11,11,11,11,11,00,09,09,00,11,00,00,11,11,11,11,11,11,11
DATA 11,11,00,12,04,00,00,12,04,00,11,11,00,12,12,12,12,00,11,11,11,11,00,12,12,12,12,00,11,00,12,12,12,00,12,12,12,00,11,11,00,11,00,09,09,00,00,09,09,00,11,00,00,11,11,11
DATA 11,11,00,12,04,00,12,04,04,00,11,00,12,04,04,04,04,04,00,11,11,00,12,04,04,04,04,04,00,11,00,12,04,12,04,04,04,04,00,00,09,00,00,09,09,00,09,00,09,09,00,09,09,00,11,11
DATA 11,11,00,12,04,12,04,04,00,11,00,12,04,04,00,00,00,12,04,00,00,12,04,04,00,00,00,12,04,00,00,12,04,04,00,00,04,04,04,00,00,09,09,09,09,00,00,00,09,09,09,09,00,09,00,11
DATA 11,11,00,12,04,04,04,04,00,11,00,12,04,00,00,00,00,12,04,00,00,12,04,00,00,00,00,12,04,00,11,00,12,04,00,11,00,04,04,00,11,00,09,09,09,09,00,11,00,09,09,00,11,00,11,11
DATA 11,00,12,12,04,04,04,04,04,00,00,12,04,12,12,12,12,04,00,11,00,12,04,12,12,12,12,04,00,11,11,00,12,04,00,11,00,12,04,00,11,00,09,09,00,00,09,00,00,09,09,00,11,11,11,11
DATA 11,00,12,04,00,00,00,04,04,00,00,12,04,04,04,04,04,00,00,00,00,12,04,04,04,04,04,00,00,00,11,00,12,04,00,11,00,12,04,00,11,00,09,09,00,11,00,11,00,09,09,00,11,11,11,11
DATA 00,12,12,04,00,11,11,00,04,04,00,12,04,04,00,00,00,00,12,04,00,12,04,04,00,00,00,00,12,00,00,12,04,04,00,11,00,12,04,00,11,00,09,09,00,00,09,00,09,09,09,00,11,00,11,11
DATA 00,12,04,04,04,00,11,00,04,04,04,00,12,04,04,04,04,04,00,00,11,00,12,04,12,12,12,12,04,00,00,12,04,00,11,11,00,12,04,00,00,09,09,00,11,11,00,09,09,00,09,09,00,09,00,11
DATA 00,12,04,04,04,00,11,00,04,04,04,00,00,04,04,04,04,04,00,11,11,11,00,04,04,04,04,04,00,11,00,04,04,00,11,00,12,04,00,11,00,09,09,00,11,11,11,00,00,11,00,09,09,00,11,11
DATA 11,00,00,00,00,11,11,11,00,00,00,11,11,00,00,00,00,00,11,11,11,11,11,00,00,00,00,00,11,11,11,00,00,11,11,00,12,04,00,11,00,09,09,00,11,11,11,11,11,11,11,00,00,11,11,11
DATA 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,12,04,00,11,11,00,09,09,00,11,11,11,11,11,11,11,11,11,11,11,11
DATA 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,12,00,00,11,00,00,09,09,00,11,11,11,11,11,11,11,11,11,11,11,11,11
DATA 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,11,11,00,09,00,09,09,00,11,11,11,11,11,11,11,11,11,11,11,11,11
DATA 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,09,09,00,11,11,11,11,11,11,11,11,11,11,11,11,11,11
DATA 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,00,00,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11

DATA 11,11,14,14,11,11,11,11
DATA 11,11,11,14,14,11,11,11
DATA 11,11,11,11,14,14,11,11
DATA 11,11,11,11,14,14,11,11
DATA 11,11,11,11,11,14,14,11
DATA 11,11,11,11,11,14,14,11
DATA 11,11,11,11,11,14,14,11
DATA 11,11,11,11,11,14,14,11
DATA 11,11,11,11,11,14,14,11
DATA 11,11,11,11,11,14,14,11
DATA 11,11,11,11,14,14,11,11
DATA 11,11,11,11,14,14,11,11
DATA 11,11,11,14,14,11,11,11
DATA 11,11,14,14,11,11,11,11

REM $STATIC
DEFSNG A-Z
SUB drawbackdrop
  LOCATE 1, 1
  COLOR 15, 10

  'PowerMenuish background
  FOR i = 1 TO 24
    PRINT STRING$(80, 176);
  NEXT

  'Heading
  LOCATE 2, 3
  COLOR 15, 12
  PRINT CHR$(201); STRING$(50, 205); CHR$(187)
  LOCATE 3, 3
  PRINT CHR$(186); " KeenFX:Vorticons                                 "; CHR$(186)
  LOCATE 4, 3
  PRINT CHR$(200); STRING$(50, 205); CHR$(188)
  'Heading shadow
  COLOR 7, 10
  LOCATE 3, 2
  PRINT CHR$(176);
  LOCATE 4, 2
  PRINT CHR$(176);
  LOCATE 5, 2
  PRINT STRING$(52, 176);
  'Version
  LOCATE 2, 58
  COLOR 15, 12
  PRINT CHR$(201); STRING$(19, 205); CHR$(187)
  LOCATE 3, 58
  PRINT CHR$(186); "    "; version; "    "; CHR$(186)
  LOCATE 4, 58
  PRINT CHR$(200); STRING$(19, 205); CHR$(188)
  'Version shadow
  COLOR 7, 10
  LOCATE 3, 57
  PRINT CHR$(176);
  LOCATE 4, 57
  PRINT CHR$(176);
  LOCATE 5, 57
  PRINT STRING$(21, 176);
  'Remaining window shadows
  FOR i = 1 TO numberofwindows
    COLOR 7, 10
    FOR j = win(i).ypos + 1 TO win(i).ypos + win(i).ysize
      LOCATE j, win(i).xpos - 1
      PRINT CHR$(176)
    NEXT
    LOCATE win(i).ypos + win(i).ysize + 1, win(i).xpos - 1
    PRINT STRING$(win(i).xsize, 176)
  NEXT
END SUB

DEFINT A-Z
FUNCTION Edit (Column, Row, Length, Text$)
'Edit function for easy input of strings.
'Wouter Bergmann Tiest
'<W.M.BergmannTiest@fys.ruu.nl>
'8th December 1995

'To use this function, replace the code between the dashed lines with your
'own.

  'Initial values
  KeyPressed = 0
  InsertSwitch = -1 'True
  COLOR FgCol, BgCol
  Position = LEN(Text$)

  'Main loop
  DO
    LOCATE Row, Column, 0
    PRINT Text$; SPACE$(Length - LEN(Text$));
    IF InsertSwitch = -1 THEN
      LOCATE Row, Position + Column, 1, 7, 8 'Line cursor
    ELSE
      LOCATE Row, Position + Column, 1, 0, 8 'Block cursor
    END IF
    DO
      Key$ = INKEY$
    LOOP WHILE Key$ = ""
    SELECT CASE ASC(Key$)
      CASE Escape
        KeyPressed = Escape
      CASE Enter
        KeyPressed = Enter
      CASE Backspace
        IF Position > 0 THEN
          Text$ = LEFT$(Text$, Position - 1) + RIGHT$(Text$, LEN(Text$) - Position)
          Position = Position - 1
        END IF
      CASE 0 'Extended codes
        SELECT CASE ASC(RIGHT$(Key$, 1))
         CASE Home
            Position = 0
          CASE LeftArrow
            IF Position > 0 THEN Position = Position - 1
          CASE RightArrow
            IF Position < LEN(Text$) THEN Position = Position + 1
          CASE EndKey
            Position = LEN(Text$)
          CASE Del
            IF Position < LEN(Text$) THEN Text$ = LEFT$(Text$, Position) + RIGHT$(Text$, LEN(Text$) - Position - 1)
          CASE Ins
            InsertSwitch = -1 - InsertSwitch
          CASE UpArrow
            KeyPressed = UpArrow
          CASE DownArrow
            KeyPressed = DownArrow
        END SELECT
      CASE IS >= 32 'Normal characters
        IF InsertSwitch = -1 THEN
          IF LEN(Text$) < Length THEN
            Text$ = LEFT$(Text$, Position) + Key$ + RIGHT$(Text$, LEN(Text$) - Position)
            Position = Position + 1
          END IF
        ELSEIF Position < Length THEN
          IF Position = LEN(Text$) THEN
            Text$ = Text$ + Key$
          ELSE
            MID$(Text$, Position + 1, 1) = Key$
          END IF
          Position = Position + 1
        END IF
    END SELECT
  LOOP UNTIL KeyPressed > 0
  LOCATE Row, Column, 0
  COLOR FgCol, BgCol
  PRINT Text$; SPACE$(Length - LEN(Text$));
  Edit = KeyPressed

END FUNCTION

DEFSNG A-Z
SUB redrawwindows
  FOR i = 1 TO numberofwindows
    IF win(i).redraw = FALSE THEN GOTO skipdraw
    COLOR 7, win(i).BgCol
    IF i = wincur THEN COLOR 15

    LOCATE win(i).ypos, win(i).xpos
    PRINT CHR$(201); " "; wintitle(i); " "; STRING$(win(i).xsize - 4 - LEN(wintitle(i)), 205); CHR$(187)
   
    FOR j = 0 TO win(i).ysize - 2
      LOCATE win(i).ypos + j + 1, win(i).xpos
      PRINT CHR$(186);
      LOCATE , win(i).xpos + win(i).xsize - 1
      PRINT CHR$(186)
    NEXT
   
    LOCATE win(i).ypos + win(i).ysize, win(i).xpos
    PRINT CHR$(200); STRING$(win(i).xsize - 2, 205); CHR$(188)
skipdraw:
  NEXT

  IF win(winsound).redraw = TRUE THEN
    FOR i = 1 TO win(winsound).ysize - 1
      LOCATE i + win(winsound).ypos, win(winsound).xpos + 1
      COLOR 0, 7
      PRINT USING "##"; i + win(winsound).viewoffset - 1;
      COLOR 7, win(winsound).BgCol
      IF currentsound = i + win(winsound).viewoffset - 1 THEN COLOR 0, 7
      PRINT USING " &"; snd(i + win(winsound).viewoffset - 1).sndname
    NEXT
  END IF

  IF win(winvis).redraw = TRUE THEN
    COLOR 7, win(winvis).BgCol
    FOR i = 0 TO win(winvis).ysize - 2
      LOCATE win(winvis).ypos + 1 + i, win(winvis).xpos + 1
      PRINT STRING$(win(winvis).xsize - 2, 0);
    NEXT

    IF wincur = winvis THEN COLOR 15    'Highlight if focused

    LOCATE win(winvis).ypos + win(winvis).ysize, win(winvis).xpos + 2
    PRINT USING " ### "; win(winvis).viewoffset  'Display view offset
   
    'Visualise the sound effect
   
  wordnote = MID$(soundeffect(currentsound), currentnote * 2 - 1, 2)
  longnote = ASC(MID$(wordnote, 2))
  longnote = longnote * 256 + ASC(wordnote)
   
   
    'yrel is location of bottom of window
    IF 65536 - longnote <= range \ 2 THEN 'Within half-window of top limit?
      yrel = 65536 - range                'Centre view one screen from top
    ELSEIF longnote <= range \ 2 THEN     'Within half-window of lower limit?
      yrel = 0                            'Centre view at bottom
    ELSE
      yrel = longnote - range \ 2         'Otherwise centre view on current note
    END IF

    FOR i = 1 TO win(winvis).xsize - 2
      wordnote = MID$(soundeffect(currentsound), (win(winvis).viewoffset + i) * 2 - 1, 2)'Get the current two bytes
     
      longtempnote = ASC(MID$(wordnote, 2))           'Convert 2-byte string to long integer for easier calculations
      longtempnote = longtempnote * 256 + ASC(wordnote)  'For some reason it doesn't like multiplying by 256 directly =(:.)-

      IF win(winvis).viewoffset + i = currentnote THEN
        COLOR 15
        LOCATE win(winvis).ypos + win(winvis).ysize, win(winvis).xpos + win(winvis).xsize - 9
        PRINT USING " ##### "; longnote  'Selected note in decial.
      END IF
    
      IF win(winvis).viewoffset + i <> currentnote THEN COLOR 7
      
      IF longtempnote >= yrel AND longtempnote < yrel + range THEN
        LOCATE win(winvis).ypos + win(winvis).ysize - 2 - (longtempnote - yrel) * 12 / range, win(winvis).xpos + i
        PRINT "*"
      ELSEIF longtempnote < yrel THEN
        LOCATE win(winvis).ypos + win(winvis).ysize - 1, win(winvis).xpos + i
        PRINT "v"
      ELSE
        LOCATE win(winvis).ypos + 1, win(winvis).xpos + i
        PRINT "^"
      END IF
'      LOCATE i, 40
'      PRINT USING " y ##### ltn ##### ln ##### y12 ########"; yrel; longtempnote; longnote; dblyoffset

      IF i >= soundlength(currentsound) / 2 THEN EXIT FOR
    NEXT
  END IF

  FOR i = 1 TO numberofwindows
    win(i).redraw = FALSE
  NEXT
END SUB

